unit Settings;

interface

uses
  Classes, Forms, Menus, StdCtrls, Controls, ShellApi, Messages, Windows,
  SysUtils, ComCtrls, XPMan;

type
  TFormSettings = class(TForm)

    pmSet: TPopupMenu;
    pmSet_Close: TMenuItem;
    PageControl1: TPageControl;
    tab_General: TTabSheet;
    tab_HotKeys: TTabSheet;
    lab_YouCanDragLng: TLabel;
    edt_Lng: TEdit;
    btn_Lng_Open: TButton;
    ch_Autostart: TCheckBox;
    ch_RunMinimizedToTray: TCheckBox;
    cb_IconOnRestore: TComboBox;
    lab_OnRestoreIcon: TLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ch_CloseToTray: TCheckBox;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pmSet_CloseClick(Sender: TObject);
    procedure btn_Lng_OpenClick(Sender: TObject);
    procedure cb_IconOnRestoreChange(Sender: TObject);

    private
      procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;

  end;

var
  FormSettings: TFormSettings;
  procedure SettingsRun;

implementation

uses
Main,
kuModul,
Individual,
iLanguage,
kuLanguageUni,
kuTray,
kuShell,
kuY;

{$R *.dfm}





//============================================================================== Settings
procedure SettingsRun;
{  -    }
begin with FormSettings do begin


DragAcceptFiles(Handle, true);

ch_Autostart.Checked := Form1.Act_Set_Autostart.Checked;
ch_Autostart.Action  := Form1.Act_Set_Autostart;

ch_RunMinimizedToTray.Checked := Form1.Act_Set_RunMinimizedToTray.Checked;
ch_RunMinimizedToTray.Action  := Form1.Act_Set_RunMinimizedToTray;


case _IconIn
of
  //itNone:       cb_IconOnRestore.ItemIndex := 0;
  inBar:        cb_IconOnRestore.ItemIndex := 0;
  inTray:       cb_IconOnRestore.ItemIndex := 1;
  inBarAndTray: cb_IconOnRestore.ItemIndex := 2;
end;

ch_CloseToTray.Checked := Form1.Act_Set_CloseToTray.Checked;
ch_CloseToTray.Action  := Form1.Act_Set_CloseToTray;

FormSettings.Show;

edt_Lng.Text := Path_FullToApp(_Lng_Path);

end;end;






//------------------------------------------------------------------------------ Close
procedure TFormSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Form1.Enabled := True;
end;


//------------------------------------------------------------------------------ Icon In
procedure TFormSettings.cb_IconOnRestoreChange(Sender: TObject);
begin

case cb_IconOnRestore.ItemIndex
of
  //0: Form1.IconIn := itNone;
  0: _IconIn := inBar;
  1: _IconIn := inTray;
  2: _IconIn := inBarAndTray;
end;

ShowIconIn(_IconIn);
SetForegroundWindow(Self.Handle);

end;



//------------------------------------------------------------------------------ Drop
procedure TFormSettings.WMDropFiles(var Msg: TWMDropFiles);
//uses shellapi;
const
  maxlen = 254;
  
var
  //i,
  count : integer;
  h: THandle;
  s: string;
  pchr: array[0..maxlen] of char;
  
  
  
begin
          
h := Msg.Drop;
  
//      ,
//      ,   :
{
  num := DragQueryFile(h, Dword(-1), nil, 0);
  for i := 0 to num-1
  do
  begin
       DragQueryFile(h, i, pchr, maxlen);
       ... ...
  end;
}

count := DragQueryFile(h, Dword(-1), pchr, maxlen);
if count <> 1
then
begin
    YY('    ', 'Form1 Drop (WMDropFiles)');
    exit;
end;


DragQueryFile(h, 0, pchr, maxlen);
s := string(pchr);   
  
  
if FileExists(s) = False
then
begin
    YY(s +#10#13+ '  !',  'Form1 Drop (WMDropFiles)');
    exit;
end;
  

  
  
if lowercase( extractfileext(s) ) = '.lng'
then
begin
    Lng_SETUP(s, true);
    exit;
end;
  
  
  
  
//if (lowercase( extractfileext(s) ) = '.ktg') or (lowercase( extractfileext(s) ) = _Kat_pExt_)
//then
//begin 
//    if vt_Type = vt_Norm
//    then//     ?
//    begin
//        case YNC_(_Kat_SaveChanges_Q, lab_KatPath.Caption)
//        of
//        {Y}  0: Act_File_Save.Execute;
//        {C}  2: exit;
//        end;
//    end;
//  
//    Kat_Open(s);
//    exit;
//end;
  
  
  
YY(_File_DragDropCanFiles,   'FormSettings Drop (WMDropFiles)');
  
  
DragFinish(h); //???
  
  
end;







//------------------------------------------------------------------------------ btn Lng
procedure TFormSettings.btn_Lng_OpenClick(Sender: TObject);
begin
Form1.Act_Set_Lng.Execute;
end;

         
//------------------------------------------------------------------------------ pm Close
procedure TFormSettings.pmSet_CloseClick(Sender: TObject);
begin
FormSettings.Close;

end;





end.
