unit kuShell;
{
 2019
    :    ,    ,   , .
:  
kuzduk@mail.ru
http://kuzduk.000webhostapp.com
}

interface

uses Forms, Classes, SysUtils, ShellApi, ShlObj, ClipBrd, Windows, Registry,
     Graphics, Controls, ActiveX, ComObj, math;

type

{ Clipboard }
TClipboardSendType = (stCopy = 5, stCut = 2); //     

procedure Clipboard_Send(const DataPaths: TStrings; const SendType: TClipboardSendType);
procedure Clipboard_Copy(const DataPaths: TStrings);
procedure Clipboard_Cut(const DataPaths: TStrings);
procedure Clipboard_Paste(const Target: string);
function  Clipboard_GetSendType: TClipboardSendType;
procedure Clipboard_GetPaths(var PathsList: TStrings; h: THandle);
function  Clipboard_GetPath1: string;


{ Shell Contex Menu }
function  ShellContexMenu_Is(FileType, MenuText, Command: string): Boolean;
procedure ShellContexMenu_Add(FileType, RegNodText, MenuText, IconPath, Command: string);
procedure ShellContexMenu_Delete(FileType, MenuText: string);


{ Associate }
function  Associate_GetRegStr(ext: string; FullRegStr: Boolean): string;
function  Associate_GetProgPath(Path: string): string;
procedure Associate_Add (const ext, ProgPath: string);
procedure Associate_Delete(ext: string);
function  Associate_Is(const ext, ProgPath: string): Boolean;
procedure Associate_Prot(const Prot, ProgPath: string);
procedure Associate_Url;

procedure OpenWith_Add(const ext, ProgPath: string);


{ AutoStart Reg }
function  AutoStart_Is(const MyProgramName, FullPath: string): Boolean;
procedure AutoStart_Add(const MyProgramName, FullPath: string);
procedure AutoStart_Delete(const MyProgramName, FullPath: string);


{ Shell Link }
procedure Link_Execute1(const FilePath: string);
procedure Link_Execute(Link: string; Prefix: string = '');
function  Link_MailtoSpecString(MailAddres, Subject, Body: string): string;
procedure Link_MailTo(MailAddres, Subject: string; Body: string = '');
procedure Link_FolderOpenAndFileSelect(const FilePath: string);


{ Param Str }
procedure GetParamStrIco(ParamStr: string; var Path_:string; var Index_: Integer);
function  GetParamStrr(P: PChar; var Param: string): PChar;
function  GetParamStr1(ParamStr: string): string;
function  GetParamStrKU(ParamStr: string; ParamNum: integer): string;


{ Aver }
function IsAdmin: Boolean;
function ShellSpecStr(Strs: TStrings): string; overload;
function ShellSpecStr(const Str: string): string; overload;
procedure File_ShellProperties(const FilePath: string);




implementation


uses
 kuModul,
 kuIconize,
 kuY;





{$REGION '   Clipboard   '}



//------------------------------------------------------------------------------ Send
procedure Clipboard_Send(const DataPaths: TStrings; const SendType: TClipboardSendType);
{
   /    :
  stCopy = (   Ctrl+C)
  stCut  = (   Ctrl+X)
      (Ctrl+V)      .

  uses ShlObj, ClipBrd, Windows;
}

var
DropFiles: PDropFiles;
hGlobal: THandle;
iLen: Integer;
f: Cardinal;
d: PCardinal;
DataSpecialList: string; // (FullPaths) /   /


begin

if DataPaths = nil then exit;
if DataPaths.Count = 0 then exit;


Clipboard.Open;
Clipboard.Clear;

//  -
DataSpecialList := ShellSpecStr(DataPaths);


iLen := Length(DataSpecialList) * SizeOf(Char);
hGlobal := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, SizeOf(TDropFiles) + iLen);
Win32Check(hGlobal <> 0);
DropFiles := GlobalLock(hGlobal);
DropFiles^.pFiles := SizeOf(TDropFiles);

{$IFDEF UNICODE}
DropFiles^.fWide := true;
{$ENDIF}

Move(DataSpecialList[1], (PansiChar(DropFiles) + SizeOf(TDropFiles))^, iLen);
SetClipboardData(CF_HDROP, hGlobal);
GlobalUnlock(hGlobal);



f := RegisterClipboardFormat(CFSTR_PREFERREDDROPEFFECT);
hGlobal := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, sizeof(dword));
d := PCardinal(GlobalLock(hGlobal));

case SendType of
  stCopy: d^ := Cardinal(stCopy);
  stCut:  d^ := Cardinal(stCut);
end;

SetClipboardData(f, hGlobal);
GlobalUnlock(hGlobal);


Clipboard.Close;

end;



//------------------------------------------------------------------------------ Copy
procedure Clipboard_Copy(const DataPaths: TStrings);
begin
Clipboard_Send(DataPaths, stCopy);
end;



//------------------------------------------------------------------------------ Cut
procedure Clipboard_Cut(const DataPaths: TStrings);
begin
Clipboard_Send(DataPaths, stCut);
end;



//------------------------------------------------------------------------------ Paste
procedure Clipboard_Paste(const Target: string);
{
        /,
   /(Ctrl+C / Ctrl+X)    -  (, )

  Target -      
  Clipboard_OperationType -      :   
}

var
  h : THandle;
  sr : string;
  DataList: TStrings;

begin

// ,    
//  /,  /,  
//CF_HDROP -     .
//      ,    DragQueryFile.
if not Clipboard.HasFormat(CF_HDROP) then exit;


Clipboard.Open;

try

  h := Clipboard.GetAsHandle(CF_HDROP);

  if h <> 0
  then
  begin

        DataList := TStringList.Create;
        ClipBoard_GetPaths(DataList, h);

        sr := DataList[0];           //Path 1
        sr := ExtractFilePath(sr);   //  Path 1


        if IncludeTrailingBackslash(AnsiUpperCase(sr)) = IncludeTrailingBackslash(AnsiUpperCase(Target))

        then// :  copy   paste
        begin
              case Clipboard_GetSendType
              of
                 stCopy: FilesShellOperations(DataList, target, FO_COPY, FOF_SIMPLEPROGRESS or FOF_RENAMEONCOLLISION );
                 stCut:  FilesShellOperations(DataList, target, FO_MOVE, FOF_SIMPLEPROGRESS );
              end;
        end

        else
        begin
              case Clipboard_GetSendType
              of
                 stCopy: FilesShellOperations(DataList, target, FO_COPY, FOF_SIMPLEPROGRESS );
                 stCut:  FilesShellOperations(DataList, target, FO_MOVE, FOF_SIMPLEPROGRESS );
              end;
        end;

  end;

finally
    Clipboard.Close;
    DataList.Free;
end;

end;



//------------------------------------------------------------------------------ Get Send Type
function Clipboard_GetSendType: TClipboardSendType;
{
         :     

        ClipBoard_DataPaste,
        (Ctrl+V):   .
}
var
   ClipFormat, hn: Cardinal;
   szBuffer: array[0..511] of Char;
   FormatID: string;
   pMem: Pointer;
   i: integer;


begin

Result := stCopy;

if not OpenClipboard(Application.Handle) then exit;


try
  ClipFormat := EnumClipboardFormats(0);

  while (ClipFormat <> 0)
  do
  begin

      GetClipboardFormatName(ClipFormat, szBuffer, SizeOf(szBuffer));
      FormatID := string(szBuffer);

      if SameText(FormatID, 'Preferred DropEffect')
      then
      begin
           hn := GetClipboardData(ClipFormat);
           pMem := GlobalLock(hn);

           Move(pMem^, i, 4); // send
           case i of
               integer(stCopy) : Result := stCopy;
               integer(stCut)  : Result := stCut;
           end;

           GlobalUnlock(hn);
           Break;
      end;

      ClipFormat := EnumClipboardFormats(ClipFormat);

  end;

  finally
  CloseClipboard;
end;


end;



//------------------------------------------------------------------------------ Get Paths
procedure Clipboard_GetPaths(var PathsList: TStrings; h: THandle);
{
     PathsList  /,      .
       :
  1)  Ctrl+C  Ctrl+X     .
  2)  Drag&Drop
}

var
  FullPath: array [0..MAX_PATH] of Char;
  i, FileCount: Integer;

begin

//  Ctrl+X  Ctrl+C,    Drag&Drop.  Drag&Drop   Handle
//if h = 0
//then
//begin
//  if not Clipboard.HasFormat(CF_HDROP) then exit;
//
//  Clipboard.Open;
//  try
//    h := Clipboard.GetAsHandle(CF_HDROP);
//  finally
//    Clipboard.Close;
//  end;
//end;

PathsList.Clear;

if h = 0 then exit;


FileCount := DragQueryFile(h, $FFFFFFFF, nil, 0);

for i := 0 to FileCount - 1
do
begin
      DragQueryFile(h, i, FullPath, SizeOf(FullPath));
      PathsList.Add(FullPath);
end;


end;



//------------------------------------------------------------------------------ Get Path 1
function Clipboard_GetPath1: string;
{
        
  ,    ,       
}
var
  s: string;
  i: integer;

begin

s := Clipboard.AsText;

if (pos(#10, s) <> 0) and (pos(#13, s) <> 0)
then
begin
    i := min(  pos(#10, s), pos(#13, s)  );
    s := copy( s, 1, i - 1 );
end;

Str_Filter_Right(s, #0);
Str_Filter_Right(s, #10);
Str_Filter_Right(s, #13);

Result := s;

end;



{$ENDREGION}





{$REGION '   Auto Start   '}
//  /    (     )



//------------------------------------------------------------------------------ Is
function  AutoStart_Is(const MyProgramName, FullPath: string): Boolean;
//,     
var reg: TRegistry;

begin
Result := False;

reg:= TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;

if reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Run', False)
then
begin
    if reg.ReadString(MyProgramName) = FullPath
    then Result := True;

    reg.CloseKey;
    reg.Free;
end;

//if Result
//then ShowMessage('   ')
//else ShowMessage('   ')

end;



//------------------------------------------------------------------------------ Add
procedure AutoStart_Add(const MyProgramName, FullPath: string);
//   
//      FullPath = Application.ExeName
var reg: TRegistry;

begin

if AutoStart_Is(MyProgramName, FullPath) then exit;

reg:= TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;

if reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Run', True)
then
begin
    reg.WriteString(MyProgramName, FullPath);
    reg.CloseKey;
    reg.Free;
end;

//ShowMessage('  ');

end;



//------------------------------------------------------------------------------ Delete
procedure AutoStart_Delete(const MyProgramName, FullPath: string);
//   
var reg: TRegistry;

begin

if not AutoStart_Is(MyProgramName, FullPath) then exit;

reg := TRegistry.Create;
reg.RootKey := HKEY_LOCAL_MACHINE;
//reg.LazyWrite := false;
reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false);
reg.DeleteValue(MyProgramName);
reg.free;

//ShowMessage('  ');

end;





{$ENDREGION}





{$REGION '   Shell Context Menu   '}




//------------------------------------------------------------------------------ is
function  ShellContexMenu_Is(FileType, MenuText, Command: string): Boolean;
//,         
var
  reg: TRegistry;

begin
Result := False;

reg := TRegistry.Create;
reg.RootKey := HKEY_CLASSES_ROOT;

//1)
if Reg.KeyExists(FileType + '\shell\' + MenuText)
then
begin
    Reg.OpenKey(FileType + '\shell\' + MenuText + '\command', True);
    if Reg.ReadString('') = Command
    then Result := True;
//    ShowMessage(Reg.ReadString(''));
    Reg.CloseKey;
end;

//if Result
//then ShowMessage(' ')
//else ShowMessage(' ');

reg.Free;

end;



//------------------------------------------------------------------------------ Add
procedure ShellContexMenu_Add(FileType, RegNodText, MenuText, IconPath, Command: string);
{
FileType -    ! :
.doc ---     doc
Folder  Directory ---  
* ---    
%1 -        
}
var
  reg: TRegistry;

begin

Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

Reg.OpenKey(FileType + '\shell\' + RegNodText, True);
Reg.WriteString('', MenuText);
Reg.WriteString('Icon', IconPath);
Reg.CloseKey;

Reg.OpenKey(FileType + '\shell\' + RegNodText + '\command', True);
Reg.WriteString('', Command);
Reg.CloseKey;


Reg.Free;

end;



//------------------------------------------------------------------------------ Delete
procedure ShellContexMenu_Delete(FileType, MenuText: string);
//  MenuText     FileType
var
  reg: TRegistry;

begin

Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;


if Reg.KeyExists(FileType)
then
begin
//  ShowMessage('     1 ');
  Reg.DeleteKey(FileType + '\shell\' + MenuText);
end;


Reg.Free;

end;




{$ENDREGION}






{$REGION '   Associate   '}




{$REGION '        '}
{

  : 
\shell\open\command


   :

HKEY_CLASSES_ROOT\.ext -       :
HKEY_CLASSES_ROOT\extfile -      .ext \shell\open\command -   ? .. extfile    


HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.ext
HKEY_LOCAL_MACHINE\SOFTWARE\Classes\extfile


HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ext        \UserChoice---Progid -       (   ?)
HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\extfile -  !


HKEY_CURRENT_USER\Software\Classes\.ext - ???     ???



   :
\DefaultIcon
\shellex\IconHandler - ??  ??
}
{$ENDREGION}





//------------------------------------------------------------------------------ Add
procedure Associate_Add(const ext, ProgPath: string);
var
Reg: TRegistry;
Key, Pere: string;




    procedure RegAddAssoc(extkey: string);
    begin
      Reg.OpenKey(extkey + '\shell\open\command', true);
      Reg.WriteString('', ProgPath + ' "%1"');
      Reg.CloseKey;

  //    Reg.OpenKey(s + '\shell\open', false);
  //    Reg.DeleteValue('');
  //    Reg.CloseKey;
    end;




begin

Reg := TRegistry.Create;



{$REGION ' HKEY_CLASSES_ROOT '}

Reg.RootKey := HKEY_CLASSES_ROOT;




{$REGION ' .ext '}

Key := '.' + ext;
RegAddAssoc(Key);//   .ext

{$ENDREGION}





{$REGION '  '}

Reg.OpenKey(Key, true);

Pere := Reg.ReadString('');  //  ,  

if Pere = '' //      
then
begin
  Pere := ext + 'file';
  Reg.WriteString('', Pere);
end;

Reg.CloseKey;

RegAddAssoc(Pere);

{$ENDREGION}




{$ENDREGION}





{$REGION ' HKEY_CURRENT_USER Progid '}

Reg.RootKey := HKEY_CURRENT_USER;
Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext + '\UserChoice';
Reg.DeleteKey(Key);


//s := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext + '\UserChoice';
//Reg.DeleteKey(s);
//Reg.OpenKey(s, true);
//Reg.WriteString('Progid', '.' + Ext);
//Reg.CloseKey;

//Reg.OpenKey(Key, false);
//Reg.WriteString('Progid', '.' + Ext);
//Reg.CloseKey;

//s := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext;
//
//if Reg.KeyExists(s)
//then
//begin
//
//  s := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext + '\UserChoice';
//
//
//  if (s <> '') and Reg.KeyExists(s)
//
//  then//  
//  begin
////    s := s
//  end
//
//  else//  
//  begin
//    s := '.' + Ext;
//  end;
//
//  RegAddAssoc(reg, s)
//
//end;


{$ENDREGION}


Reg.Free;


//   "  "
OpenWith_Add(ext, ProgPath);


//         :
//Iconize_FileType;
//Shell_ico_Refresh;

end;



//------------------------------------------------------------------------------ Is
function Associate_Is(const ext, ProgPath: string): Boolean;
begin

Result := (Associate_GetRegStr(ext, False) = ProgPath);

end;



//------------------------------------------------------------------------------ Delete
procedure Associate_Delete(ext: string);
var
  Reg: TRegistry;
  Key, Pere: string;

begin

//if Ext[1] <> '.' then Ext := '.' + Ext;

Reg := TRegistry.Create;


{$REGION ' HKEY_CLASSES_ROOT '}

Reg.RootKey := HKEY_CLASSES_ROOT;
Key := '.' + Ext;
Reg.OpenKey(Key, False);
Pere := Reg.ReadString('');
Reg.CloseKey;
Reg.DeleteKey(Key  + '\shell\open\command');

if Pere <> '' then
Reg.DeleteKey(Pere + '\shell\open\command');

{$ENDREGION}




{$REGION ' HKEY_CURRENT_USER Progid '}

Reg.RootKey := HKEY_CURRENT_USER;
Reg.DeleteKey('Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext);
Reg.CloseKey;

{$ENDREGION}



Reg.Free;

//  :
Shell_ico_Refresh;

end;






//------------------------------------------------------------------------------ Get Reg Str
function Associate_GetRegStr(ext: string; FullRegStr: Boolean): string;
//    :      
//
//FullRegStr -      ,         ext
//true -     
//false -   ?      
var
 Reg: TRegistry;
 s, key: string;


begin
Result := '';



{$REGION ' CURRENT_USER Progid '}
Reg := TRegistry.Create;
Reg.RootKey := HKEY_CURRENT_USER;

key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext +'\UserChoice';


if Reg.KeyExists(key)
then
begin
    if Reg.OpenKeyReadOnly(key)
    then
    begin
        s := Reg.ReadString('Progid'); //   ()
//        yy('   (): ' + s);
        Reg.CloseKey;

        if s = ''

        then Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext +'\shell\open\command'

        else
        begin
//            reg.Free;
//            Reg := TRegistry.Create;
            Reg.RootKey := HKEY_CLASSES_ROOT;

            if Reg.KeyExists(s)
            then key := s + '\shell\open\command';
        end;

        Reg.OpenKeyReadOnly(key);
        s := reg.ReadString('');
    end;


    if s <> ''
    then
    begin
        if FullRegStr
        then Result := s
        else Result := GetParamStr1(s);

        Reg.CloseKey;
        Reg.Free;
        exit;
    end;
end;


Reg.Free;
{$ENDREGION}




{$REGION ' HKEY_CLASSES_ROOT .ext '}
Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

key := '.' + Ext;

if Reg.KeyExists(key)
then
begin
    if Reg.OpenKeyReadOnly(key)
    then
    begin
        s := Reg.ReadString(''); //   ()
//        yy('   (): ' + s);
        reg.CloseKey;

        if (s <> '') and reg.KeyExists(s)
        then key := s;

        key := key + '\shell\open\command';


        reg.OpenKeyReadOnly(key);
        s := reg.ReadString('');
//        yy(s);
    end;

    if s <> ''
    then Result := GetParamStr1(s);
//        yy(result);
    Reg.CloseKey;
end;


Reg.Free;
{$ENDREGION}



end;



//------------------------------------------------------------------------------ Get Prog Path
function Associate_GetProgPath(Path: string): string;
//        inPath
//     .. inPath      

var
  t, ext : string;


begin
Result := '';


Path := Path_RelativToFull(Path);  //    



//.lnk
if Lnk_Test(Path, t) then Path := t;





ext  := AnsiLowerCase( File_ExtOnly(Path) );


{$REGION ' exe '}
if ext = 'exe'
then
begin
    Result := Path;
    exit;
end;
{$ENDREGION}





{$REGION '    '}
begin
  Path := Associate_GetRegStr(ext, False);
  Result := Path;
end;
{$ENDREGION}



//yy(result);
end;






//------------------------------------------------------------------------------ Protocol
procedure Associate_Prot(const Prot, ProgPath: string);
var
Reg: TRegistry;
Adr: string;

begin

Reg := TRegistry.Create;



{$REGION ' Prot '}

Reg.RootKey := HKEY_CLASSES_ROOT;

Reg.OpenKey(Prot, true);
Reg.DeleteValue(''); //   
Reg.CloseKey;

Reg.OpenKey(Prot + '\shell\open\command', true);
Reg.WriteString('', ProgPath + ' "%1"');
Reg.CloseKey;

{$ENDREGION}




{$REGION ' Progid '}

if (Prot = 'http') or (Prot = 'https')
then
begin

  Reg.RootKey := HKEY_CURRENT_USER;
  Adr := 'Software\Microsoft\Windows\Shell\Associations\UrlAssociations\' +Prot+ '\UserChoice';

  if Reg.OpenKey(Adr, false) then
  if Reg.ValueExists('Progid')
  then
  begin
      Reg.DeleteKey(Adr);
      Reg.OpenKey  (Adr, true);
      Reg.WriteString('Progid', Prot);
      Reg.CloseKey;
  end;
end;

{$ENDREGION}




Reg.Free;

//         :
//Iconize_FileType;
//Shell_ico_Refresh;

end;



//------------------------------------------------------------------------------ url
procedure Associate_Url;
var
Reg: TRegistry;

begin

Reg := TRegistry.Create;

Reg.RootKey := HKEY_CLASSES_ROOT;

//Reg.OpenKey(Prot, true);
//Reg.DeleteValue(''); //   
//Reg.CloseKey;

Reg.OpenKey('.url\shell\open\command', true);
//Reg.DeleteValue(''); //   
Reg.WriteString('', '"C:\Windows\System32\rundll32.exe" "C:\Windows\System32\ieframe.dll",OpenURL %l');
Reg.CloseKey;

Reg.Free;



end;



//------------------------------------------------------------------------------ ico
procedure Associate_Ico(ProgPath: String);
var
Reg: TRegistry;

begin

Reg := TRegistry.Create;

Reg.RootKey := HKEY_CLASSES_ROOT;

//Reg.OpenKey(Prot, true);
//Reg.DeleteValue(''); //   
//Reg.CloseKey;

Reg.OpenKey('.url\shell\open\command', true);
//Reg.DeleteValue(''); //   
Reg.WriteString('', '"C:\Windows\System32\rundll32.exe" "C:\Windows\System32\ieframe.dll",OpenURL %l');
Reg.CloseKey;

Reg.Free;

end;






//------------------------------------------------------------------------------ AddToOpenWith
procedure OpenWith_Add(const ext, ProgPath: string{; MenuItemCaption: string = 'Program'});
var
Reg: TRegistry;
Key: string;

begin

if ext = 'http' then exit;
if ext = 'https' then exit;
if ext = 'mailto'then exit;
//if ext = 'url' then exit;
//if ext = 'exe' then exit;
//if ext = 'bat' then exit;
//if ext = 'lnk' then exit;


Reg := TRegistry.Create;
Reg.RootKey := HKEY_CURRENT_USER;
Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext + '\OpenWithList';
Reg.OpenKey(Key, true);
Reg.WriteString('a', ProgPath);
Reg.CloseKey;

Reg.Free;

end;



{$ENDREGION}






{$REGION '   Link   '}


//------------------------------------------------------------------------------ Execute 1
procedure Link_Execute1(const FilePath: string);
//   
begin

ShellExecute
(
  Application.Handle,
  'open',
  pWideChar(FilePath),  //   
  nil,
  nil,
  SW_SHOWNORMAL
)

end;


//------------------------------------------------------------------------------ Execute
procedure Link_Execute(Link: string; Prefix: string = '');
begin

if Link = '' then exit;

if Prefix <> '' then Link := Prefix + Link;

Link := Path_RelativToFull(Link); //    

Link_Execute1(Link);

end;



//------------------------------------------------------------------------------ Open Folder and Select File
procedure Link_FolderOpenAndFileSelect(const FilePath: string);
begin

ShellExecute
(
  Application.Handle,
  'open',
  'explorer',
  pWideChar('/select, "' + FilePath + '" '),
  nil,
  SW_NORMAL
);

end;



//------------------------------------------------------------------------------ Mailto Spec string
function Link_MailtoSpecString(MailAddres, Subject, Body: string): string;
{
     -   mailto://

  mailto://
    (   http://)

  lalala@lala.ru
   ,    ,    ";"

  ?
     
  par1=value1
      

  &
   

   mailto   :
  MAILTO:Recipients&Parameters
   Recipients   ,       ,   ";"
   Parameters           "&".       name/value.     :

  Parameter description:

  CC=
  Carbon copy ( )
  BCC=
  Blind carbon copy ( ,      )
  SUBJECT=
  Subject text ()
  BODY=
  Body text ()

           Internet safe characters.  %0d     (LF), %20     .

  :
  mailto:email1;email2&cc=email3?subject=%20&
  body=%20%20%0d%20%20
}
begin

Result := 'mailto://' + MailAddres + '?subject=' + Subject + '&body=' + Body

end;



//------------------------------------------------------------------------------ MailTo
procedure Link_MailTo(MailAddres, Subject: string; Body: string = '');
begin

Link_Execute1( Link_MailtoSpecString(MailAddres, Subject, Body) );

end;



{$ENDREGION}






{$REGION '   Param Str   '}



//------------------------------------------------------------------------------ Get Param Str
function GetParamStrr(P: PChar; var Param: string): PChar;
//      

var
  i, Len: Integer;
  Start, S: PChar;
begin
  // U-OK
  while True
  do
  begin
    while (P[0] <> #0) and (P[0] <= ' ')
     do Inc(P);

    if (P[0] = '"') and (P[1] = '"')
    then Inc(P, 2)
    else Break;
  end;

  Len := 0;
  Start := P;

  while P[0] > ' '
  do
  begin
    if P[0] = '"'
    then
    begin
        Inc(P);
        while (P[0] <> #0) and (P[0] <> '"')
        do
        begin
          Inc(Len);
          Inc(P);
        end;
        if P[0] <> #0 then Inc(P);
    end

    else
    begin
        Inc(Len);
        Inc(P);
    end;
  end;

  SetLength(Param, Len);

  P := Start;
  S := Pointer(Param);
  i := 0;
  while P[0] > ' '
  do
  begin
    if P[0] = '"'
    then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"')
      do
      begin
        S[i] := P^;
        Inc(P);
        Inc(i);
      end;
      if P[0] <> #0 then Inc(P);
    end

    else
    begin
      S[i] := P^;
      Inc(P);
      Inc(i);
    end;
  end;

  Result := P;
end;




//------------------------------------------------------------------------------ Get Param Str 1
function GetParamStr1(ParamStr: string): string;
//    :
//"ProgrammPath" "A" "Z"
//ProgrammPath "A" "Z"


var
p: integer;
param: string;

begin

Result := '';

Str_Filter_Left(ParamStr, ' ');
Str_Filter_Left(ParamStr, #0);

if ParamStr = '' then exit;


if ParamStr[1] = '"'

then
begin
//yy('1');
    if str_find_Next('"', ParamStr, false, 2, p)
    then param := copy(ParamStr, 2, p - 2)
end

else
begin
//yy('2');
    p := pos('"', ParamStr);
    if p <> 0
       then param := copy(ParamStr, 1, p - 1)
       else param := ParamStr;
end;

Str_Filter_Right(param, ' ');
Str_Filter_Right(param, #0);

Result := param;

//yy(result, 'GetParamStr1');

end;


//------------------------------------------------------------------------------ Get Param Str 2
function GetParamStr2(ParamStr: string): string;
//..!!!!
var
s: string;
i, p: integer;


begin

s := GetParamStr1(ParamStr);

i := Length(s);
if i = 0 then exit;

p := pos(s, ParamStr);
if p = 0 then exit;

i := Length(ParamStr);
if p + 1 < i then exit;

paramStr := copy(ParamStr, p + 1, i);
//Str_Filter



end;


//------------------------------------------------------------------------------ Get Param Str 12
procedure GetParamStr12beta(ParamStr: string; var param1, param2: string);
// 1  2   :
//Param1,Param2
//"Param1",Param2
//    


var
i, p: integer;
param: string;

begin
Str_Filter_Left(ParamStr, ' ');
Str_Filter_Left(ParamStr, #0);

if ParamStr = '' then exit;


if ParamStr[1] = '"'

then
begin
//yy('1');
    if str_find_Next('"', ParamStr, false, 2, p)
    then
    begin
        if p = 0 then exit;

        param1 := copy(ParamStr, 2, p - 2);

        i := Length(ParamStr);
        if p + 1 > i then exit;

        //  
        paramStr := copy(ParamStr, p + 1, i);


        Str_Filter_Left(ParamStr, ' ');
        Str_Filter_Left(ParamStr, ',');
        param2 := paramStr
    end;
end

else
begin
//yy('2');
    p := pos('"', ParamStr);
    if p <> 0 then param := copy(ParamStr, 1, p - 1);
end;


end;



//------------------------------------------------------------------------------ Path and Index from ParamStr
procedure GetParamStrIco(ParamStr: string; var Path_:string; var Index_: Integer);
//      2 :
//Param1,Param2
//   : ,
var
  s1, s2: string;
  i: integer;


begin
Index_ := 0;

ParamStr := Str_Sub_Delete(ParamStr, '"');
s2 := File_ExtOnly(ParamStr);

if s2 = ''
then
begin
  Path_ := ParamStr;
  exit;
end;


i := pos(',', s2);

if i = 0

then
begin
  Path_ := ParamStr;
  exit;
end

else
begin

  if length(s2) > i
  then
  begin
    s1 := copy(ParamStr, 1, length(ParamStr) - length(s2) + i - 1);
    Path_ := trim(s1);

    s2 := copy(s2, i + 1, length(s2));
    s2 := trim(s2);
    if Str_inNabor(s2, '0123456789')
    then Index_ := strtoint(s2)
  end;

end;

end;



//------------------------------------------------------------------------------ Get Param Str 1
function GetParamStrKU(ParamStr: string; ParamNum: integer): string;
//    :
//"ProgrammPath" "A" "Z"
//ProgrammPath "A" "Z"

var
p: integer;
param: string;
paramList: TStrings;

label lab_end;

begin
Result := '';



paramList := TStringList.Create;

while true
do
begin
    Str_Filter_Left(ParamStr, ' ');
    Str_Filter_Left(ParamStr, ',');
    Str_Filter_Left(ParamStr, #0);

    if ParamStr = '' then goto lab_end;

    if ParamStr[1] = '"'

    then
    begin

        if str_find_Next('"', ParamStr, false, 2, p)
        then
        begin
            param := copy(ParamStr, 2, p - 2);
            if p <> Length(ParamStr) then ParamStr := copy(ParamStr, p + 1, Length(ParamStr))
        end;
    end

    else
    begin
    //yy('2');
        p := pos('"', ParamStr);
        if p <> 0 then param := copy(ParamStr, 1, p - 1);
    end;
end;


Str_Filter_Right(param, ' ');
Str_Filter_Right(param, #0);

lab_end:

Result := paramList[ParamNum];

//yy(result, 'GetParamStr1');

end;



{$ENDREGION}






{$REGION '   Aver   '}


//------------------------------------------------------------------------------ Shell Spec Str
function ShellSpecStr(Strs: TStrings): string; overload;
{
    TStirngs  -   
    -    #0
    -  #0#0
}
var
s: string;
i: integer;

begin

for i := 0 to Strs.Count - 1
do s := s + Strs[i] + #0;

Result := s + #0;

end;


//------------------------------------------------------------------------------ Shell Spec Str
function ShellSpecStr(const Str: string): string; overload;
begin

Result :=  Str + #0#0;

end;



//------------------------------------------------------------------------------ Res Get Icons
procedure Res_GetIcons(FileName: String; SmallImages, LargeImages: TImageList);
{
      *.exe  *.dll   ...
      SmallImages  LargeImages
}
var
Icon : TIcon; //  
CountIcon : DWORD; //      
i : DWORD; // 
SM, LR : HICON; //     

begin



//var IconIndex : word;

//  IconIndex := SpinEdit1.Value;
//  Image1.Picture.Icon.Handle := ExtractAssociatedIcon(HInstance, Pchar(Edit1.Text),IconIndex);
//  Image1.Picture.Icon.SaveToFile('c:\Users\\Desktop\1.ico');



//     
CountIcon := ExtractIcon( HInstance, PChar( FileName ), UINT(-1) );

if CountIcon = 0 then exit;


//   TIcon    
Icon := TIcon.Create;

try
  //      
  for i := 0 to CountIcon
  do
  begin
      //      i
      ExtractIconEx( PChar( FileName ), i, LR, SM, 1);

      //    Icon,           
      Icon.Handle := SM;

      //     
      SmallImages.AddIcon( Icon );


      Icon.Handle := LR;

      //     
      LargeImages.AddIcon( Icon );
  end;

finally
  Icon.Free;//  
end;


end;




//------------------------------------------------------------------------------ Is Amin
function IsAdmin: Boolean;
//      
var
 i: integer;
 bSuccess: BOOL;
 hAccessToken: THandle;
 ptgGroups: PTokenGroups;
 dwInfoBufferSize: DWORD;
 psidAdministrators: PSID;

const
 SECURITY_NT_AUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
 SECURITY_BUILTIN_DOMAIN_RID = $00000020;
 DOMAIN_ALIAS_RID_ADMINS     = $00000220;

begin

Result := false;
bSuccess := OpenThreadToken(GetCurrentThread, TOKEN_QUERY, true, hAccessToken);

if not bSuccess
then
begin
   if GetLastError=ERROR_NO_TOKEN
   then bSuccess:=OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, hAccessToken);
end;

if bSuccess
then
begin
   GetMem(ptgGroups, 1024);
   bSuccess:=GetTokenInformation(hAccessToken, TokenGroups, ptgGroups, 1024, dwInfoBufferSize);
   CloseHandle(hAccessToken);

   if bSuccess
   then
   begin
       AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, psidAdministrators);

       {$R-}
       for i := 0 to ptgGroups.GroupCount-1
       do
        if EqualSid(psidAdministrators, ptgGroups.Groups[i].Sid)
        then
        begin
          Result := true;
          Break;
        end;
       {$R+}

      FreeSid(psidAdministrators);
   end;

   FreeMem(ptgGroups);
end;


end;



//------------------------------------------------------------------------------
procedure File_ShellProperties(const FilePath: string);
var
 sei: TShellExecuteinfo;

begin

//if not FileExists(FilePath) then exit;

FillChar(sei, sizeof(sei), 0);
sei.cbSize := sizeof(sei);
sei.lpFile := Pchar(FilePath);
sei.lpVerb := 'properties';
sei.fMask := SEE_MASK_INVOKEIDLIST;
ShellExecuteEx(@sei);

end;



{$ENDREGION}





end.
